LeetCode每日一题 | 1690. 石子游戏 VII

文章目录

题目描述

原题链接

石子游戏中,爱丽丝和鲍勃轮流进行自己的回合,爱丽丝先开始 。

有 n 块石子排成一排。每个玩家的回合中,可以从行中 移除 最左边的石头或最右边的石头,并获得与该行中剩余石头值之 和 相等的得分。当没有石头可移除时,得分较高者获胜。

鲍勃发现他总是输掉游戏(可怜的鲍勃,他总是输),所以他决定尽力 减小得分的差值 。爱丽丝的目标是最大限度地 扩大得分的差值 。

给你一个整数数组 stones ,其中 stonesi 表示 从左边开始 的第 i 个石头的值,如果爱丽丝和鲍勃都 发挥出最佳水平 ,请返回他们 得分的差值 。

问题分析

记sum[i]为前 i 个石头的值之和

状态定义 :dp[i][j]表示从第 i 个石头到第 j 个石头,他们得分的差值

状态计算 :dp[i][j] = max(sum[j + 1] - sum[i + 1] - dp[i + 1][j], sum[j] - sum[i] - dp[i][j - 1])

边界条件 :dp[i][i] = 0

程序代码

go 复制代码
func stoneGameVII(stones []int) int {
    n := len(stones)
    sum := make([]int, n + 1)
    dp := make([][]int, n)
    for i := 0; i < n; i++ {
        dp[i] = make([]int, n)
    }

    for i := 0; i < n; i++ {
        sum[i + 1] = sum[i] + stones[i]
    }
    
    for s := 2; s <= n; s++ {
        for i := 0; i <= n - s; i++ {
            j := i + s - 1
            dp[i][j] = max(sum[j + 1] - sum[i + 1] - dp[i + 1][j], sum[j] - sum[i] - dp[i][j - 1])
        }
    } 

    return dp[0][n-1]
}
相关推荐
basketball61612 小时前
动态规划第一章:引论
算法·动态规划·1024程序员节
星夜离尘5612 小时前
MATLAB 因果采样保持:用历史匹配和数据年龄防止未来信息泄漏
数据结构·算法·matlab
思麟呀12 小时前
BTree的原理与 C++ 完整实现
c语言·数据结构·c++·算法·1024程序员节
Tsuki_tl13 小时前
【优选算法 — 双指针】经典例题题解+算法总结
算法·蓝桥杯·力扣·刷题·双指针·1024程序员节·优选算法
拓恒技术14 小时前
内河航道无人机智能巡检系统与算法应用
人工智能·深度学习·算法·无人机·智慧城市
如何原谅奋力过但无声14 小时前
【LeetCode hot100】代码随想录未cover部分
数据结构·算法·leetcode
INGNIGHT14 小时前
377.组合总和 Ⅳ(背包)
c++·算法·1024程序员节
拓恒技术14 小时前
城市管理中的无人机AI识别算法:架构、场景与落地
人工智能·算法·视觉检测·无人机·1024程序员节
吴可可12315 小时前
Accumark二次开发环境搭建与API入门
算法
文丑颜不良啊15 小时前
LeetCode701~725题目解析
java·leetcode